<template lang="pug">
.card
	.card-header( v-if='title' )
		.card-header-title( v-html='title' )
		.card-header-icon( v-if='$slots.icon' )
			slot( name="icon" )
	.card-content
		slot
	.card-footer( v-if='footerComponents.length' )
		component.card-footer-item( v-for='(component, i) in footerComponents' :is='component' )
</template>

<script setup>
import { computed, useSlots } from "vue"
const props = defineProps({
	title: String
})


const slots = useSlots()
const footerComponents = computed(() => {
	if (!slots.footer) return []
	
	let items = []

	for (let component of slots.footer()) {
		if (typeof component.type == "symbol" && component.children !== "v-if") {
			items.push( ...component.children )
		} else {
			items.push(component)
		}
	}

	return items
})
</script>